@echo off
:: This patcher script was evolved by Immorpher, Phredreeke, Molecicco and Scwiba this first section can be edited
	echo Welcome to Fastest Shovels 3

	:: Define WAD name
	set WADFile=FastestShovels3.wad

:: --------------------------------------------------------------------------------------------------
:: Be careful editing after this point

:: Look locally first so the player can choose where to mod
	set appdir=
		if exist "%appdir%Doom64.kpf" goto runwad

:: Look for the GOG installation of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\GOG.com\Games\1456611261" /v path 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf" goto runwad
	
:: Look for the Steam installation of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Steam App 1148590" /v InstallLocation 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf" goto runwad

:: Look for the Epic Games installation of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Nahimic\NahimicAPO4\NahimicSettings\Applications\DOOM64_x64.exe" /v MatchedExeFullPath 2^> nul`) DO (
		set appdir=%%A %%B
		)
		set appdir=%appdir:~0,-14%
	if exist "%appdir%Doom64.kpf" goto runwad
	
:: Look for Bethesda version
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\DOOM 64\" /v Path 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf" goto runwad
	
:: Look for Game Pass version
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_CLASSES_ROOT\Local Settings\Software\Microsoft\Windows\CurrentVersion\AppModel\Repository\Packages\BethesdaSoftworks.Doom641997_2.0.0.0_x64__3275kfvn8vcwc" /v PackageRootFolder 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf" goto runwad
	
:: Look for other common directories
	:: Set the directory array
	set appdir=C:\Program Files\GOG Galaxy\Games\DOOM 64\
		if exist "%appdir%Doom64.kpf" goto runwad
	set appdir=C:\Program Files\Steam\steamapps\common\Doom 64\
		if exist "%appdir%Doom64.kpf" goto runwad
	set appdir=C:\Program Files\Epic Games\DOOM64\
		if exist "%appdir%Doom64.kpf" goto runwad
	set appdir=D:\Program Files\GOG Galaxy\Games\DOOM 64\
		if exist "%appdir%Doom64.kpf" goto runwad
	set appdir=D:\Program Files\Steam\steamapps\common\Doom 64\
		if exist "%appdir%Doom64.kpf" goto runwad
	set appdir=D:\Program Files\Epic Games\DOOM64\
		if exist "%appdir%Doom64.kpf" goto runwad
	
:: If no KPF found notify user
	goto notfound
	
:: Unable to find the files to patch
:notfound
	echo Failed to find the correct directory - Attempting to load anyway
	set appdir=
	goto runwad
	
:: Try to run the WAD
:runwad
	echo Loading the mod... Check for any window prompts!
	"%appdir%DOOM64_x64" -file "%cd%\%WADFile%" -skipmovies -fast
	pause
	goto :eof